//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QtSupport;

/**

 The <code>CharacterData</code> interface extends Node with a set
 of attributes and methods for accessing character data in the DOM.
 For clarity this set is defined here rather than on each object
 that uses these attributes and methods. No DOM objects correspond
 directly to <code>CharacterData</code> , though <code>Text</code>
 and others do inherit the interface from it. All
 <code>offset</code>s in this interface start from 0.
 		@short    The <code>CharacterData</code> interface extends Node with a set  of attributes and methods for accessing character data in the DOM.

*/
public class CharacterData extends Node  {
	protected CharacterData(Class dummy){super((Class) null);}
	public CharacterData() {
		super((Class) null);
		newCharacterData();
	}
	private native void newCharacterData();
	public CharacterData(CharacterData other) {
		super((Class) null);
		newCharacterData(other);
	}
	private native void newCharacterData(CharacterData other);
	public CharacterData(Node other) {
		super((Class) null);
		newCharacterData(other);
	}
	private native void newCharacterData(Node other);
	/**	
		 The character data of the node that implements this interface.
		 The DOM implementation may not put arbitrary limits on the
		 amount of data that may be stored in a <code>CharacterData</code>
		 node. However, implementation limits may mean that the
		 entirety of a node's data may not fit into a single
		 <code>DOMString</code> . In such cases, the user may call
		 <code>substringData</code> to retrieve the data in appropriately
		 sized pieces.
			     		@short    The character data of the node that implements this interface.
	*/
	public native String data();
	/**	
		 see data
			     		@short    see data
	*/
	public native void setData(String arg1);
	/**	
		 The number of characters that are available through <code>data</code>
		 and the <code>substringData</code> method below. This
		 may have the value zero, i.e., <code>CharacterData</code>
		 nodes may be empty.
			     		@short    The number of characters that are available through <code>data</code>  and the <code>substringData</code> method below.
	*/
	public native long length();
	/**	
		 Extracts a range of data from the node.
			@param offset Start offset of substring to extract.
			@param count The number of characters to extract.
			  DOMSTRING_SIZE_ERR: Raised if the specified range of text does
		 not fit into a <code>DOMString</code> .
			     		@return The specified substring. If the sum of <code>offset</code>
 and <code>count</code> exceeds the <code>length</code>
  , then all characters to the end of the data are
 returned.

		@short    Extracts a range of data from the node.
	*/
	public native String substringData(long offset, long count);
	/**	
		 Append the string to the end of the character data of the node.
		 Upon success, <code>data</code> provides access to the
		 concatenation of <code>data</code> and the <code>DOMString</code>
		 specified.
			@param arg The <code>DOMString</code> to append.
			     		@short    Append the string to the end of the character data of the node.
	*/
	public native void appendData(String arg);
	/**	
		 Insert a string at the specified character offset.
			@param offset The character offset at which to insert.
			@param arg The <code>DOMString</code> to insert.
			  NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
			     		@short    Insert a string at the specified character offset.
	*/
	public native void insertData(long offset, String arg);
	/**	
		 Remove a range of characters from the node. Upon success,
		 <code>data</code> and <code>length</code> reflect the
		 change.
			@param offset The offset from which to remove characters.
			@param count The number of characters to delete. If the sum of
		 <code>offset</code> and <code>count</code> exceeds
		 <code>length</code> then all characters from <code>offset</code>
		 to the end of the data are deleted.
			  NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
			     		@short    Remove a range of characters from the node.
	*/
	public native void deleteData(long offset, long count);
	/**	
		 Replace the characters starting at the specified character
		 offset with the specified string.
			@param offset The offset from which to start replacing.
			@param count The number of characters to replace. If the sum of
		 <code>offset</code> and <code>count</code> exceeds
		 <code>length</code> , then all characters to the end of the data are
		 replaced (i.e., the effect is the same as a <code>remove</code>
		 method call with the same range, followed by an
		 <code>append</code> method invocation).
			@param arg The <code>DOMString</code> with which the range
		 must be replaced.
			  NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
			     		@short    Replace the characters starting at the specified character  offset with the specified string.
	*/
	public native void replaceData(long offset, long count, String arg);
	// DOM::CharacterData* CharacterData(DOM::CharacterDataImpl* arg1); >>>> NOT CONVERTED
}
