//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QMetaObject;
import org.kde.qt.QtSupport;
import org.kde.qt.QWidget;
import org.kde.qt.QWidget;

/**

 The base class for control center modules.
 Starting from KDE 2.0, control center modules are realized as shared
 libraries that are loaded into the control center at runtime.
 The module in principle is a simple widget displaying the
 item to be changed. The module has a very small interface.
 All the necessary glue logic and the GUI bells and whistles
 are provided by the control center and must not concern
 the module author.
 To write a config module, you have to create a library
 that contains at one factory function like this:
 <pre>
 #include <kgenericfactory.h>
 typedef KGenericFactory<YourKCModule, QWidget> YourKCModuleFactory;
 K_EXPORT_COMPONENT_FACTORY( yourLibName, YourKCModuleFactory("name_of_the_po_file") );
 </pre>
 The parameter "name_of_the_po_file" has to correspond with the messages target
 that you created in your Makefile.am.
 See http://developer.kde.org/documentation/other/kcm_howto.html
 for more detailed documentation.
 See {@link KCModuleSignals} for signals emitted by KCModule
		@author Matthias Hoelzer-Kluepfel <hoelzer@kde.org>
 
		@short    The base class for control center modules.

*/
public class KCModule extends QWidget  {
	protected KCModule(Class dummy){super((Class) null);}
	/**	
		 An enumeration type for the buttons used by this module.
		 You should only use Help, Default and Apply. The rest is obsolete.
				@short    An enumeration type for the buttons used by this module.
		@see KCModule#buttons
		@see @see
		@see KCModule#setButtons
	*/
	public static final int Help = 1;
	public static final int Default = 2;
	public static final int Apply = 16;
	public static final int Reset = 4;
	public static final int Cancel = 8;
	public static final int Ok = 32;
	public static final int SysDefault = 64;

	public native QMetaObject metaObject();
	public native String className();
	public KCModule(QWidget parent, String name, String[] args) {
		super((Class) null);
		newKCModule(parent,name,args);
	}
	private native void newKCModule(QWidget parent, String name, String[] args);
	public KCModule(QWidget parent, String name) {
		super((Class) null);
		newKCModule(parent,name);
	}
	private native void newKCModule(QWidget parent, String name);
	public KCModule(QWidget parent) {
		super((Class) null);
		newKCModule(parent);
	}
	private native void newKCModule(QWidget parent);
	public KCModule() {
		super((Class) null);
		newKCModule();
	}
	private native void newKCModule();
	public KCModule(KInstanceInterface instance, QWidget parent, String[] args) {
		super((Class) null);
		newKCModule(instance,parent,args);
	}
	private native void newKCModule(KInstanceInterface instance, QWidget parent, String[] args);
	public KCModule(KInstanceInterface instance, QWidget parent) {
		super((Class) null);
		newKCModule(instance,parent);
	}
	private native void newKCModule(KInstanceInterface instance, QWidget parent);
	public KCModule(KInstanceInterface instance) {
		super((Class) null);
		newKCModule(instance);
	}
	private native void newKCModule(KInstanceInterface instance);
	/**	
		 Load the configuration data into the module.
			 The load method sets the user interface elements of the
		 module to reflect the current settings stored in the
		 configuration files.
			 This method is invoked whenever the module should read its configuration
		 (most of the times from a config file) and update the user interface.
		 This happens when the user clicks the "Reset" button in the control
		 center, to undo all of his changes and restore the currently valid
		 settings. 
			 If you use KConfigXT, loading is taken care of automatically and 
		 you do not need to do it manually. However, if you for some reason reimplement it and
		 also are using KConfigXT, you must call this function otherwise the loading of KConfigXT 
		 options will not work.
			   		@short    Load the configuration data into the module.
	*/
	public native void load();
	/**	
		 Save the configuration data.
			 The save method stores the config information as shown
		 in the user interface in the config files.
			 If necessary, this method also updates the running system,
		 e.g. by restarting applications. This normally does not apply for
		 KSettings.Dialog modules where the updating is taken care of by
		 KSettings.Dispatcher.
			 save is called when the user clicks "Apply" or "Ok".
			 If you use KConfigXT, saving is taken care off automatically and 
		 you do not need to load manually. However, if you for some reason reimplement it and
		 also are using KConfigXT, you must call this function, otherwise the saving of KConfigXT 
		 options will not work. Call it at the very end of your reimplementation, to avoid
		 changed() signals getting emitted when you modify widgets.
		   		@short    Save the configuration data.
	*/
	public native void save();
	/**	
		 Sets the configuration to sensible default values.
			 This method is called when the user clicks the "Default"
		 button. It should set the display to useful values.
			 If you use KConfigXT, you do not have to reimplement this function since
		 the fetching and settings of default values is done automatically. However, if you 
		 reimplement and also are using KConfigXT, remember to call the base function at the 
		 very end of your reimplementation.
		   		@short    Sets the configuration to sensible default values.
	*/
	public native void defaults();
	/**	
		 Set the configuration to system default values.
			 This method is called when the user clicks the "System-Default"
		 button. It should set the display to the system default values.
			 @note The default behavior is to call defaults().
		   		@short    Set the configuration to system default values.
	*/
	public native void sysdefaults();
	/**	
		 Return a quick-help text.
			 This method is called when the module is docked.
		 The quick-help text should contain a short description of the module and
		 links to the module's help files. You can use QML formatting tags in the text.
			 @note make sure the quick help text gets translated (use i18n()).
		   		@short    Return a quick-help text.
	*/
	public native String quickHelp();
	/**	
		 This is generally only called for the KBugReport.
		 If you override you should  have it return a pointer to a constant.
				@return the KAboutData for this module
   
		@short    This is generally only called for the KBugReport.
	*/
	public native KAboutData aboutData();
	/**	
		 This sets the KAboutData returned by aboutData()
				@short    This sets the KAboutData returned by aboutData()
	*/
	public native void setAboutData(KAboutData about);
	/**	
		 Indicate which buttons will be used.
			 The return value is a value or'ed together from
		 the Button enumeration type.
				@short    Indicate which buttons will be used.
		@see KCModule#setButtons
	*/
	public native int buttons();
	/**	
		 Get the RootOnly message for this module.
			 When the module must be run as root, or acts differently
		 for root and a normal user, it is sometimes useful to
		 customize the message that appears at the top of the module
		 when used as a normal user. This function returns this
		 customized message. If none has been set, a default message
		 will be used.
				@short    Get the RootOnly message for this module.
		@see KCModule#setRootOnlyMsg
	*/
	public native String rootOnlyMsg();
	/**	
		 Tell if KControl should show a RootOnly message when run as
		 a normal user.
			 In some cases, the module don't want a RootOnly message to
		 appear (for example if it has already one). This function
		 tells KControl if a RootOnly message should be shown
				@short    Tell if KControl should show a RootOnly message when run as  a normal user.
		@see KCModule#setUseRootOnlyMsg
	*/
	public native boolean useRootOnlyMsg();
	public native KInstanceInterface instance();
	/**	
				@return a list of @ref KConfigDialogManager's in use, if any.

		@short
	*/
	// const QPtrList<KConfigDialogManager>& configs(); >>>> NOT CONVERTED
	/**	
		 Adds a KConfigskeleton <code>config</code> to watch the widget <code>widget</code>
			 This function is useful if you need to handle multiple configuration files.
			@param config the KConfigSkeleton to use
			@param widget the widget to watch
		   		@return a pointer to the KConfigDialogManager in use

		@short    Adds a KConfigskeleton <code>config</code> to watch the widget <code>widget</code>
	*/
	// KConfigDialogManager* addConfig(KConfigSkeleton* arg1,QWidget* arg2); >>>> NOT CONVERTED
	/**	
		 Sets the quick help.
				@short    Sets the quick help.
	*/
	protected native void setQuickHelp(String help);
	/**	
		 Sets the buttons to display.
			 Help: shows a "Help" button.
		 Default: shows a "Use Defaults" button
		 Apply: in kcontrol this will show an "Apply" and "Reset" button
		        in kcmshell this will show an "Ok", "Apply" and "Cancel" button
			 If Apply is not specified, kcmshell will show a "Close" button.
				@short    Sets the buttons to display.
		@see KCModule#buttons
	*/
	protected native void setButtons(int btn);
	/**	
		 Sets the RootOnly message.
			 This message will be shown at the top of the module of the
		 corresponding desktop file contains the line X-KDE-RootOnly=true.
		 If no message is set, a default one will be used.
				@short    Sets the RootOnly message.
		@see KCModule#rootOnlyMsg
	*/
	protected native void setRootOnlyMsg(String msg);
	/**	
		 Change whether or not the RootOnly message should be shown.
			 Following the value of <code>on</code>, the RootOnly message will be
		 shown or not.
				@short    Change whether or not the RootOnly message should be shown.
		@see KCModule#useRootOnlyMsg
	*/
	protected native void setUseRootOnlyMsg(boolean on);
	/**	
		 Returns the changed state of automatically managed widgets in this dialog
				@short    Returns the changed state of automatically managed widgets in this dialog
	*/
	protected native boolean managedWidgetChangeState();
	/**	
		 Call this method when your manually managed widgets change state between
		 changed and not changed
				@short    Call this method when your manually managed widgets change state between  changed and not changed
	*/
	protected native void unmanagedWidgetChangeState(boolean arg1);
	/**	
		 Calling this slot is equivalent to emitting changed(true).
				@short    Calling this slot is equivalent to emitting changed(true).
	*/
	protected native void changed();
	/**	
		 A managed widget was changed, the widget settings and the current
		 settings are compared and a corresponding changed() signal is emitted
				@short    A managed widget was changed, the widget settings and the current  settings are compared and a corresponding changed() signal is emitted
	*/
	protected native void widgetChanged();
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
